/*******************************************************************************
 									CoAN-013 application
               Web Interface with real-time charts using AJAX
*******************************************************************************/
#class auto
#memmap xmem


/*************************************************
*		 NETWORK CONFIGURATION 							 *
**************************************************/
#define TCPCONFIG 1
#define _PRIMARY_STATIC_IP 	"10.0.0.55"
#define _PRIMARY_NETMASK		"255.255.255.0"
#define MY_GATEWAY 				"10.0.0.1"

/*************************************************
*  Networking modules invocation						 *
**************************************************/
#use "dcrtcp.lib"
#define USE_RABBITWEB 1
//max length re-definition (some path names are very long)
#define SSPEC_MAXNAME	  30
#define HTTP_MAXNAME      SSPEC_MAXNAME
#use "http.lib"

/*************************************************
*  application modules for this project			 *
**************************************************/
#use "iweb.lib"     		//web interface objects
#use "datetime.lib"  	//date&time utilities

/*************************************************
*		variables for samples simulations			 *
**************************************************/
float ad_inputs[8];
const char chanDesc[][20] =
{
	"ln(x)",
   "e^x",
   "x^2",
   "2*x + 5",
   "square",
   "random()",
   "sin(x)",
   "cos(x)"
};


int i, flag;
float x0,x1,x2,x3;

const char appName[] = "Real Time Chart Demo";
const char ip[] = _PRIMARY_STATIC_IP;
main()
{
	//Web Server Start Up
 	iweb_init();

   x0 =  0.09;
   x1 = -0.9;
   x2 = -50;
   x3 = -50;

	while(1)
   {
      http_handler();//Web server attention...

      /***********************************************************************
       * Simulate AD Samples
       **********************************************************************/
      costate
      {  //LOG function generator
      	x0 = ( (x0 += 0.01)< 9999999999 )? x0: 0.09;
			ad_inputs[0] = log( x0 );
         waitfor( DelayMs(250) );
      }
      costate
      {  //EXP function generator
      	x1 = ( (x1 += 0.1)< 80)?x1 : -0.9;
			ad_inputs[1] = exp( x1 );
         waitfor( DelayMs(250) );
      }
      costate
      {  //QUADRATIC function generator
      	x2 = ( (x2 += 1)< 999999)?x2 : -50;
			ad_inputs[2] = x2 * x2;
         waitfor( DelayMs(250) );
      }
      costate
      {  //LINEAR function generator
	      x3 = ( (x3 += 1)< 99999999)? x3: -50;
			ad_inputs[3] = 2*x3 + 5;
         waitfor( DelayMs(250) );
      }
      costate
      {  //SQUARE wave generator
			ad_inputs[4] = (flag)? 3.3: 0;
         waitfor( DelayMs(1000) );
         flag = !flag;
      }
      costate
      {  //RANDOM value generator
			ad_inputs[5] = rand();
         waitfor( DelayMs(250) );
      }
      costate
      {  //SINE & COSINE functions generator
      	#define 	SIN_RESOLUTION				16      //Semi-cycle resolution
			#define 	SIN_AMPL						10      //Amplitude
      	for(i=-SIN_RESOLUTION; i<=SIN_RESOLUTION; i++)
         {
         	ad_inputs[6] = sin( i * (3.14159/SIN_RESOLUTION)  ) * SIN_AMPL;
            ad_inputs[7] = cos( i * (3.14159/SIN_RESOLUTION)  ) * SIN_AMPL;
	         waitfor( DelayMs(250) );
         }
         i= -SIN_RESOLUTION;
      }
	}
}


